<?php

/**
 * Created by PhpStorm.
 * User: mohamed
 * Date: 10/06/2015
 * Time: 06:03 م
 */
class Paypal extends front_end
{
    function __construct()
    {
        parent::__construct();
        $this->load->library('Paypal_Lib');
    }

    function index()
    {
        $this->is_logged();
        $email = option_get('paypal-email');

        $key = md5(time() . $email . rand());
        $this->setup_payment(1, $email, $key);


        $this->paypal_lib->add_field('business', option_get('paypal-email'));
        $this->paypal_lib->add_field('return', site_url('paypal/success'));
        $this->paypal_lib->add_field('cancel_return', site_url('paypal/cancel'));
        $this->paypal_lib->add_field('notify_url', site_url('paypal/ipn')); // <-- IPN url

        $this->paypal_lib->add_field('item_name', option_get('paypal-amount').' '.option_get('paypal-product-name'));
        $this->paypal_lib->add_field('item_number', '1');
        $this->paypal_lib->add_field('amount', option_get('paypal-price'));

        $this->paypal_lib->add_field('custom', $key);
        $this->paypal_lib->add_field($this->security->get_csrf_token_name(), $this->security->get_csrf_hash());

        redirect($this->paypal_lib->paypal_get_request_link());
    }

    function setup_payment($item_id, $email, $key)
    {
        $this->is_logged();
        $data = array(
            'item_id' => $item_id,
            'key' => $key,
            'email' => $email,
            'active' => 0 // hasn't been purchased yet
            );
        //$this->db->insert( 'purchases', $data );
    }

    function success()
    {
        //if ($this->ipn()) {
        flash_data_success('Congratulations, your balance updated');
        $this->update_points(option_get('paypal-amount'),'+',user_id());
        redirect();
        //}

    }

    function cancel()
    {
        flash_data_warning('Payment cancelled.');
        redirect();
    }

    function ipn()
    {
        if ($this->paypal_lib->validate_ipn()) {
            $item_name = $this->paypal_lib->ipn_data['item_name'];
            $price = $this->paypal_lib->ipn_data['mc_gross'];
            $currency = $this->paypal_lib->ipn_data['mc_currency'];
            $payer_email = $this->paypal_lib->ipn_data['payer_email'];
            $txn_id = $this->paypal_lib->ipn_data['txn_id'];
            $key = $this->paypal_lib->ipn_data['transaction_subject'];
            return true;
        } else {
            return false;
        }
    }

}